/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.KelompokPegawai;
import com.portofolio.entity.vo.KelompokPegawaiId;

@Lazy
@Repository
public interface KelompokPegawaiDao extends CrudRepository<KelompokPegawai, KelompokPegawaiId> {

	@Query(QListAll)
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);
    
    @Query(QListAll + " and model.namaKelompokPegawai like %:namaKelompokPegawai% ")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaKelompokPegawai") String namaKelompokPegawai, @Param("statusEnabled") boolean statusEnabled,Pageable page);
    
    @Query(QListAll + " and model.id.kdKelompokPegawai = :kdKelompokPegawai")
    Map<String, Object> findByKdKelompokPegawai(@Param("kdProfile") Integer kdProfile, @Param("kdKelompokPegawai") String kdKelompokPegawai,@Param("statusEnabled") boolean statusEnabled);
       
    
    
    String QListAll ="select new map("
    		+ " model.id.kdKelompokPegawai as kdKelompokPegawai"
    		+ ",model.id.kdProfile as kdProfile "
            + ", model.namaKelompokPegawai as namaKelompokPegawai " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", model.version as version )" 
            + " from KelompokPegawai model left join model.id id "
            + "where id.kdProfile=:kdProfile "
            + "and model.statusEnabled = :statusEnabled "; 

}
